/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "animatedcolorattr.h"

#include "colorattribute.h"

// Visitors
#include "visitors/avisitor.h"

AnimatedColor::AnimatedColor() : Attribute(ATTR_COLOR)
{
  m_baseVal = new ColorAttribute();
  m_animVal = new ColorAttribute();
}

AnimatedColor::AnimatedColor(const AnimatedColor &other)
    : Attribute(ATTR_COLOR),
    m_baseVal(0),
    m_animVal(0)
{
  m_baseVal = new ColorAttribute();
  m_animVal = new ColorAttribute();
  (*this) = other;
}

AnimatedColor::~AnimatedColor()
{}

AnimatedColor &AnimatedColor::operator=(const AnimatedColor &other)
{
  Attribute::operator=(other);
  *m_baseVal = other.baseVal();
  *m_animVal = other.animVal();

  return *this;
}

Attribute* AnimatedColor::clone()
{
  AnimatedColor* retElem = new AnimatedColor();
  *retElem = *this;
  return ( retElem );
}

/**
 * Overrides default isValid() method and delegate request to baseVal
 * @return 
 */
bool AnimatedColor::isValid( ) const
{
  return m_baseVal->isValid();
}

void AnimatedColor::accept( AVisitor &a )
{
  a.visit(*this);
}
